<template>
  <div>
    <v-navigation-drawer
      v-model="drawer"
      :mini-variant="miniVariant"
      :clipped="clipped"
      fixed
      app
    >
      <template #prepend>
        <v-list-item two-line>
          <v-list-item-avatar>
            <img v-if="user ? user.img : false" src="user.img" />
            <div v-else class="user-icon">
              <div>{{ user ? user.sub[0] : "" }}</div>
            </div>
          </v-list-item-avatar>

          <v-list-item-content>
            <v-list-item-title>{{ user ? user.sub : "" }}</v-list-item-title>
            <v-list-item-subtitle
              ><span class="rolename">
                {{ getRoleName(role) }}</span
              ></v-list-item-subtitle
            >
          </v-list-item-content>
        </v-list-item>
      </template>

      <v-divider></v-divider>
      <v-list dense nav>
        <v-list-item v-for="(item, i) in items" :key="i" :to="item.to" link>
          <v-list-item-action>
            <v-icon>{{ item.icon }}</v-icon>
          </v-list-item-action>
          <v-list-item-content>
            <v-list-item-title>{{ item.title }} </v-list-item-title>
          </v-list-item-content>
        </v-list-item>
      </v-list>

      <template v-slot:append>
        <v-list dense nav>
          <v-list-item link @click="logoutRole" v-if="showChangeRole">
            <v-list-item-action>
              <v-icon>mdi-swap-horizontal</v-icon>
            </v-list-item-action>
            <v-list-item-content>
              <v-list-item-title>Cambio de rol</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
          <v-list-item link @click="logout">
            <v-list-item-action>
              <v-icon>mdi-logout</v-icon>
            </v-list-item-action>
            <v-list-item-content>
              <v-list-item-title>Cerrar sesión</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-list>
      </template>
    </v-navigation-drawer>
    <v-app-bar color="white" fixed app class="appbar" v-if="appbar">
      <v-app-bar-nav-icon @click="drawer = !drawer"></v-app-bar-nav-icon>
      <v-toolbar-title class="primary--text"><b>Cuidémonos</b></v-toolbar-title>
      <v-spacer></v-spacer>
    </v-app-bar>
  </div>
</template>
<script>
import { mapState, mapActions } from "vuex";
import rolesinfo from "@/assets/js/rolesinfo";
import { getFilteredRoutes } from "~/helpers/loginroute";

export default {
  data() {
    return {
      clipped: false,
      drawer: true,
      fixed: false,
      miniVariant: false,
      title: "",
    };
  },
  computed: {
    ...mapState({
      user: (state) => state.auth.user,
      items: (state) => state.roles.options,
      role: (state) => state.roles.role,
    }),
    showChangeRole() {
      const routes = getFilteredRoutes(this.user);
      return routes.length === 1 ? false : true;
    },
    appbar() {
      switch (this.$vuetify.breakpoint.name) {
          case 'xs': return true
          case 'sm': return true
          case 'md': return true
          case 'lg': return false
          case 'xl': return false
          default: return false
        }
    }
  },
  methods: {
    ...mapActions({
      logoutRoleState: "roles/logoutRole",
      logoutState: "auth/logout",
    }),
    logoutRole() {
      this.logoutRoleState();
      this.$router.push("/roles");
    },
    logout() {
      this.logoutState();
      this.$router.push("/");
    },
    getImage(user) {
      if (user.img) {
        return user.img;
      } else {
        return;
      }
    },
    getRoleName(role) {
      const obj = rolesinfo.find((el) => el.id === role);
      return obj.title;
    },
  },
};
</script>
<style lang="scss" scoped>
$size: 40px;
.user-icon {
  width: $size;
  height: $size;
  background: #85e4c6;
  border-radius: 50%;
  display: flex;
  align-items: center;
  justify-content: center;
  > div {
    color: white;
  }
}
.rolename {
  font-weight: 500;
  color: #1f7e60;
}

</style>
